VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DSPManager"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit


' Verwaltet DSPs, die DSP Chain und fhrt letztere auch aus


Implements DSP
Implements DSPChain

Private m_clsDSP()      As IPluginDSP
Private m_lngDSPCount   As Long

Private m_clsChain()    As IPluginDSP
Private m_lngChainLen   As Long

Private m_lngSamplerate As Long
Private m_lngChannels   As Long

Public Sub Add(cls As IPluginDSP)
    cls.Init Session
    DSP_Add cls
End Sub

Public Sub Process(samples() As Single, ByVal lngOffset As Long, ByVal lngSamples As Long, lngReturned As Long)
    Dim i As Long
    Dim lngNewSamples As Long
    
    lngReturned = lngSamples
    
    For i = 0 To m_lngChainLen - 1
        m_clsChain(i).ProcessSamples samples, lngOffset, lngReturned, lngNewSamples
        lngReturned = lngNewSamples
    Next
End Sub

Public Sub NextTrack()
    Dim i As Long
    
    For i = 0 To m_lngChainLen - 1
        m_clsChain(i).TrackChanged
    Next
End Sub

Public Sub FormatChanged(ByVal lngSamplerate As Long, ByVal lngChannels As Long)
    Dim i As Long
    
    m_lngSamplerate = lngSamplerate
    m_lngChannels = lngChannels
    
    For i = 0 To m_lngChainLen - 1
        m_clsChain(i).FormatChanged lngSamplerate, lngChannels
    Next
End Sub


'####################################################
'####################################################
' DSPCHAIN


Private Sub DSPChain_Add( _
    ByVal cls As MonoPluginLib.IPluginDSP, _
    Optional ByVal index As Long = -1& _
)

    Dim i As Long
    
    ReDim Preserve m_clsChain(m_lngChainLen) As IPluginDSP
    
    If Session.Playback.FileOpened Then
        cls.FormatChanged m_lngSamplerate, m_lngChannels
        cls.TrackChanged
    End If
    
    If index = -1 Then
        Set m_clsChain(m_lngChainLen) = cls
    Else
        For i = m_lngChainLen - 1 To index Step -1
            Set m_clsChain(i) = m_clsChain(i - 1)
        Next
        Set m_clsChain(index) = cls
    End If
    m_lngChainLen = m_lngChainLen + 1
End Sub

Private Sub DSPChain_Clear()
    m_lngChainLen = 0
    Erase m_clsChain
End Sub

Private Property Get DSPChain_Count() As Long
    DSPChain_Count = m_lngChainLen
End Property

Private Property Get DSPChain_Item(ByVal index As Long) As MonoPluginLib.IPluginDSP
    Set DSPChain_Item = m_clsChain(index)
End Property

Private Sub DSPChain_MoveItem( _
    ByVal indexFrom As Long, _
    ByVal indexTo As Long _
)

    Dim clsNewChain() As IPluginDSP
    Dim i As Long, j As Long
    
    ReDim clsNewChain(m_lngChainLen - 1) As IPluginDSP
    
    For i = 0 To m_lngChainLen - 1
        If indexTo < indexFrom Then If i = indexTo Then j = j + 1
        If i <> indexFrom Then
            Set clsNewChain(j) = m_clsChain(i)
            j = j + 1
        End If
        If indexTo > indexFrom Then If i = indexTo Then j = j + 1
    Next
    
    Set clsNewChain(indexTo) = m_clsChain(indexFrom)
    
    m_clsChain = clsNewChain
End Sub

Private Sub DSPChain_Remove(ByVal index As Long)
    Dim i As Long
    
    For i = index To m_lngChainLen - 2
        Set m_clsChain(index) = m_clsChain(index + 1)
    Next
    
    If m_lngChainLen = 1 Then
        Erase m_clsChain
    Else
        ReDim Preserve m_clsChain(m_lngChainLen - 2) As IPluginDSP
    End If
    m_lngChainLen = m_lngChainLen - 1
End Sub



'####################################################
'####################################################
' DSP


Private Sub DSP_Add(ByVal cls As MonoPluginLib.IPluginDSP)
    ReDim Preserve m_clsDSP(m_lngDSPCount) As IPluginDSP
    Set m_clsDSP(m_lngDSPCount) = cls
    m_lngDSPCount = m_lngDSPCount + 1
End Sub

Private Property Get DSP_Chain() As MonoPluginLib.DSPChain
    Set DSP_Chain = Me
End Property

Private Property Get DSP_Count() As Long
    DSP_Count = m_lngDSPCount
End Property

Private Property Get DSP_Item(ByVal index As Long) As MonoPluginLib.IPluginDSP
    Set DSP_Item = m_clsDSP(index)
End Property

Private Sub DSP_Remove(ByVal index As Long)
    Dim i As Long
    
    For i = index To m_lngDSPCount - 2
        Set m_clsDSP(index) = m_clsDSP(index + 1)
    Next
    
    If m_lngDSPCount = 0 Then
        Erase m_clsDSP
    Else
        ReDim Preserve m_clsDSP(m_lngDSPCount - 2) As IPluginDSP
        m_lngDSPCount = m_lngDSPCount - 1
    End If
End Sub
