VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PlaylistM3U"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit


' M3U (Extended) Playlist Handler
'
' Arne Elster 2009


Implements IPlaylist

Private Const MY_DESCRIPTION As String = "M3U Playlist"
Private Const MY_EXTENSIONS  As String = "m3u"

Private Const M3U_HEADER As String = "#EXTM3U"
Private Const M3U_EXTINF As String = "#EXTINF"

Private Property Get IPlaylist_Description() As String
    IPlaylist_Description = MY_DESCRIPTION
End Property

Private Property Get IPlaylist_Extensions() As String()
    IPlaylist_Extensions = Split(MY_EXTENSIONS, ";")
End Property

Private Function IPlaylist_ReadPlaylist( _
    ByVal clsManager As PlaylistManager, _
    ByVal strPath As String _
) As Boolean
    
    Dim fh As Integer
    Dim strBuffer As String
    Dim strLines() As String
    Dim blnExtended As Boolean
    Dim i As Long
    
    On Error GoTo ErrorHandler
    fh = FreeFile
    Open strPath For Binary As #fh
        strBuffer = Space$(LOF(fh))
        Get #fh, , strBuffer
    Close #fh
    On Error GoTo 0
    
    If InStr(strBuffer, vbLf) Then
        strLines = Split(strBuffer, vbLf)
    ElseIf InStr(strBuffer, vbCr) Then
        strLines = Split(strBuffer, vbCr)
    Else
        strLines = Split(strBuffer, ChrW$(0))
    End If
    
    If RemoveSpecialChars(strLines(0)) = M3U_HEADER Then
        For i = 1 To UBound(strLines)
            If Left$(strLines(i), Len(M3U_EXTINF)) = M3U_EXTINF Then
                Dim strDuration As String, strTitle As String, strFile As String
                
                strDuration = Mid$(strLines(i), Len(M3U_EXTINF) + 2)
                strDuration = Left$(strDuration, InStr(strDuration, ",") - 1)
                strTitle = Mid$(strLines(i), Len(M3U_EXTINF) + Len(strDuration) + 3)
                strFile = strLines(i + 1)
                
                If IsRelativePath(strFile) Then
                    If Left$(strFile, 1) = "\" Then
                        strFile = GetPath(strPath) & strFile
                    Else
                        strFile = AddSlash(GetPath(strPath)) & strFile
                    End If
                End If
                
                clsManager.AddFile RemoveSpecialChars(strLines(i + 1)), _
                                   RemoveSpecialChars(strTitle), _
                                   CLng(strDuration)
                
                ' nchste Zeile enthlt Pfad. berspringen.
                i = i + 1
            End If
        Next
    Else
        For i = 0 To UBound(strLines)
            If Trim$(strLines(i)) <> "" Then
                strLines(i) = RemoveSpecialChars(strLines(i))
                clsManager.AddFile strLines(i), GetFileName(strLines(i)), 0
            End If
        Next
    End If
    
    IPlaylist_ReadPlaylist = True
ErrorHandler:
End Function

Private Function IPlaylist_WritePlaylist( _
    ByVal clsManager As PlaylistManager, _
    ByVal strPath As String _
) As Boolean

    Dim i As Long
    Dim fh As Integer
    
    fh = FreeFile
    
    On Error GoTo ErrorHandler
    Open strPath For Output As #fh
        Print #fh, M3U_HEADER
        
        For i = 0 To clsManager.FileCount - 1
            Print #fh, M3U_EXTINF & ":";
            Print #fh, clsManager.FileDuration(i) & ",";
            Print #fh, clsManager.FileTitle(i)
            Print #fh, clsManager.FilePath(i)
        Next
    Close #fh
    On Error GoTo 0
    
    IPlaylist_WritePlaylist = True
ErrorHandler:
End Function

Private Function RemoveSpecialChars(ByVal strVal As String) As String
    strVal = Replace$(strVal, vbCr, "")
    strVal = Replace$(strVal, vbLf, "")
    RemoveSpecialChars = strVal
End Function
