Attribute VB_Name = "Visualisation"
Option Explicit


' Sehr einfache Darstellung von Signalen
' in der Zeit- und Frequenzdomne


Public Const FFT_SIZE               As Long = 1024
Public Const FFT_BITS               As Long = 10
'            FFT_BITS                       = Log(FFT_SIZE) / Log(2)

Private m_sngReInp(FFT_SIZE - 1)    As Single
Private m_sngImInp(FFT_SIZE - 1)    As Single
Private m_sngReOut(FFT_SIZE - 1)    As Single
Private m_sngImOut(FFT_SIZE - 1)    As Single
Private m_sngMagn(FFT_SIZE \ 2 - 1) As Single
Private m_sngWindow(FFT_SIZE - 1)   As Single

Public Property Get FFTData() As Single()
    FFTData = m_sngMagn
End Property

Public Sub VisInit()
    Dim i As Long
    
    ' Hanning Window fr sauberes Spektrum
    For i = 0 To FFT_SIZE - 1
        m_sngWindow(i) = 0.5 * (1 - Cos(PI2 * i / (FFT_SIZE - 1)))
    Next
End Sub

Public Sub VisSetData(sngInp() As Single, ByVal lngOffset As Long)
    Dim i As Long
    
    For i = 0 To FFT_SIZE - 1
        m_sngReInp(i) = sngInp(lngOffset + i) * m_sngWindow(i)
    Next
    
    FFT.FFT m_sngReInp, m_sngImInp, m_sngReOut, m_sngImOut, FFT_SIZE, FFT_BITS
    
    For i = 0 To FFT_SIZE \ 2 - 1
        Dim sngTemp As Single
        
        sngTemp = Sqr(m_sngReOut(i) * m_sngReOut(i) + _
                      m_sngImOut(i) * m_sngImOut(i)) / 16

        If sngTemp < 0.2 Then sngTemp = sngTemp * 4
        m_sngMagn(i) = 0.3 * m_sngMagn(i) + 0.7 * sngTemp
    Next
    
    For i = 2 To FFT_SIZE \ 2 - 1
        m_sngMagn(i) = (m_sngMagn(i - 2) + m_sngMagn(i - 1) + m_sngMagn(i)) / 3
    Next
End Sub

Private Sub Plot( _
    pb As PictureBox, _
    sngSamples() As Single, _
    ByVal n As Long, _
    ByVal center As Boolean, _
    ByVal normalize As Boolean _
)
    
    Dim dy      As Long, dy2        As Long
    Dim i       As Long
    Dim sngMax  As Single, sngVal   As Single
    Dim yL      As Single, yN       As Single
    Dim x       As Single, k        As Single
    Dim st      As Single
    
    dy = pb.ScaleHeight - 1
    dy2 = dy \ 2
    
    st = n / pb.ScaleWidth
    
    If normalize Then
        For i = 0 To n - 1
            If Abs(sngSamples(i)) > sngMax Then
                sngMax = Abs(sngSamples(i))
            End If
        Next
    End If
    
    If sngMax = 0 Then sngMax = 1
    sngVal = sngSamples(0) / sngMax
    
    If center Then
        yL = -sngVal * dy2 + dy2
        pb.ForeColor = vbWhite
    Else
        yL = dy - sngVal * dy
    End If
    
    k = k + st
    
    Do
        sngVal = sngSamples(Fix(k)) / sngMax
        
        If center Then
            yN = -sngVal * dy2 + dy2
        Else
            yN = dy - sngVal * dy
        End If
        
        pb.Line (x, yL)-(x + 1, yN)
        yL = yN
        x = x + 1
        k = k + st
    Loop While k < n
End Sub

Public Sub DrawFrequencies(ByVal picVis As PictureBox)
    picVis.ForeColor = vbWhite
    Plot picVis, m_sngMagn, FFT_SIZE \ 4, False, False
End Sub

Public Sub DrawAmplitudes(ByVal picVis As PictureBox)
    Plot picVis, m_sngReInp, FFT_SIZE, True, False
End Sub
