VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ASMWriter2"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Enum Registers
    Reg_A
    Reg_B
    Reg_C
    Reg_D
End Enum

Private Type Variable
    Name        As String
    DType       As DATA_TYPE
    StackPos    As Long
    IsGlobal    As Boolean
    IsParam     As Boolean
    MemPos      As String
End Type

Private Const ENDFNC_PREFIX As String = "exit_"

Private m_udtVars()     As Variable
Private m_lngVarCount   As Long
Private m_lngStackSize  As Long
Private m_lngLblCount   As Long
Private m_strCurFunc    As String

Private m_lngAllocAddr  As Long
Private m_lngFreeAddr   As Long

Private m_strASM        As String

Public Property Get FreeAddr() As Long
    FreeAddr = m_lngFreeAddr
End Property

Public Property Let FreeAddr(ByVal lngPtr As Long)
    m_lngFreeAddr = lngPtr
End Property

Public Property Get AllocAddress() As Long
    AllocAddress = m_lngAllocAddr
End Property

Public Property Let AllocAddress(ByVal lngPtr As Long)
    m_lngAllocAddr = lngPtr
End Property

Private Property Get VarByName( _
    ByVal strName As String, _
    ByVal udeType As DATA_TYPE _
) As Variable

    Dim i As Long
    
    For i = 0 To m_lngVarCount - 1
        If StrComp(strName, m_udtVars(i).Name, vbTextCompare) = 0 Then
            VarByName = m_udtVars(i)
            Exit Property
        End If
    Next
    
    If i = m_lngVarCount Then
        m_lngStackSize = m_lngStackSize + StackSizeFromType(udeType)
        AddVar strName, udeType, m_lngStackSize, False
        VarByName = VarByName(strName, udeType)
    End If
End Property

Private Sub ClearVars()
    Dim i As Long
    
    For i = 0 To m_lngVarCount - 1
        If Len(m_udtVars(i).Name) > 0 Then
            If Not m_udtVars(i).IsGlobal Then
                m_udtVars(i).Name = ""
            End If
        End If
    Next
    
    m_lngStackSize = 0
End Sub

Private Sub AddVar( _
    ByVal strName As String, _
    ByVal udeType As DATA_TYPE, _
    ByVal lngSPos As Long, _
    ByVal blnIsParam As Boolean, _
    Optional ByVal blnIsGlobal As Boolean = False, _
    Optional ByVal MemPos As String = "" _
)

    Dim i As Long
    
    For i = 0 To m_lngVarCount - 1
        If m_udtVars(i).Name = "" Then
            Exit For
        End If
    Next
    
    If i = m_lngVarCount Then
        ReDim Preserve m_udtVars(m_lngVarCount)
    End If
    
    With m_udtVars(i)
        .Name = strName
        .DType = udeType
        .StackPos = lngSPos
        .IsGlobal = blnIsGlobal
        .IsParam = blnIsParam
        .MemPos = MemPos
    End With
    
    If i = m_lngVarCount Then
        m_lngVarCount = m_lngVarCount + 1
    End If
End Sub

Public Function TACtoASM(ByVal ctx As TACContext) As String
    Dim i As Long
    
    m_lngVarCount = 0
    
    For i = 0 To ctx.StatementCount - 1
        If ctx.Statement(i).Command = TAC_CMD_ENTER Then
            FncToASM i, ctx
            ClearVars
        End If
    Next
    
    DeclareGlobalVars
    AddMemHandlers
    
    TACtoASM = m_strASM
End Function

Private Sub AddMemHandlers()
    AddASM "Alloc:"
    AddASM "mov " & RegName(Reg_D, TYPE_INT) & ", " & m_lngAllocAddr
    AddASM "jmp dword " & RegName(Reg_D, TYPE_INT)
    AddASM "Delete:"
    AddASM "mov " & RegName(Reg_D, TYPE_INT) & ", " & m_lngFreeAddr
    AddASM "jmp dword " & RegName(Reg_D, TYPE_INT)
End Sub

Private Sub FncToASM(i As Long, ByVal ctx As TACContext)
    Const FIXUP_STACKSIZE As String = "FIXUP_STACKSIZE"
    Dim lngParamCount As Long
    
    For i = i To ctx.StatementCount - 1
        With ctx.Statement(i)
            Select Case .Command
                Case TAC_CMD_ENTER
                    AddASMComment "ENTER"
                    m_strCurFunc = .JumpLabel
                    AddASM .JumpLabel & ":"
                    AddASM "push ebp"
                    AddASM "mov ebp, esp"
                    AddASM "sub esp, " & FIXUP_STACKSIZE
                    
                Case TAC_CMD_EXITLABEL
                    AddASM .JumpLabel & ":"
                    
                Case TAC_CMD_LEAVE
                    AddASMComment "LEAVE"
                    AddASM "add esp, " & FIXUP_STACKSIZE
                    AddASM "pop ebp"
                    AddASM "ret " & lngParamCount * 4
                    
                    ' OMG. Irgendwann mal Frame Gerst entwerfen?
                    m_strASM = Replace(m_strASM, FIXUP_STACKSIZE, _
                                       m_lngStackSize + 4)
                    
                    i = i - 1
                    Exit Sub
                    
                Case TAC_CMD_LABEL
                    AddASM .JumpLabel & ":"
                
                Case TAC_CMD_JUMP
                    AddASM "jmp dword " & .JumpLabel
                
                Case TAC_CMD_NOP
                    AddASM "nop"
                
                Case TAC_CMD_PUSH
                    AddASMComment "PUSH"
                    With .VarAssign
                        If .DoRef Then
                        
                            If .DeRef Then
                                AddASM "mov " & RegName(Reg_A, TYPE_INT) & ", " & _
                                                GetVarAddr(.VarName, .DataType)
                            Else
                                AddASM "lea " & RegName(Reg_A, TYPE_INT) & ", " & _
                                                GetVarAddr(.VarName, .DataType)
                            End If
    
                        ElseIf .DeRef Then
                            LoadAddrToReg Reg_A, ctx.Statement(i).VarAssign
                        Else
                            LoadAddrToReg Reg_A, ctx.Statement(i).VarAssign
                        End If
                    End With
                    AddASM "push " & RegName(Reg_A, TYPE_INT)
                
                Case TAC_CMD_CALL
                    AddASM "call " & .JumpLabel
                
                Case TAC_CMD_DEBUG
                    AddASM "int 3"
                
                Case TAC_CMD_ALLOC
                    LoadAddrToReg Reg_A, .VarAssign
                    AddASM "push " & RegName(Reg_A, .VarAssign.DataType)
                    AddASM "call Alloc"
                
                Case TAC_CMD_DELETE
                    LoadAddrToReg Reg_A, .VarAssign
                    AddASM "push " & RegName(Reg_A, .VarAssign.DataType)
                    AddASM "call Delete"
                
                Case TAC_CMD_RETURN
                    AddASMComment "RETURN"
                    
                    Dim j As Long
                    
                    If Not .VarAssign Is Nothing Then
                        ' EBX darf von Windows nicht angefasst werden
                        ' ALSO UNTEN AUFPASSEN, DASS REG_B NICHT
                        ' ANGEFASST WIRD!
                        LoadAddrToReg Reg_B, .VarAssign
                    End If
                    
                    ' Lokale Arrays freigeben
                    For j = 0 To m_lngVarCount - 1
                        Dim strJmpLbl As String
                        With m_udtVars(j)
                            If (Not .IsGlobal) And _
                               (Not .IsParam) And _
                               (.DType And TYPE_ARRAY) Then
                               
                                strJmpLbl = CreateLabel()
                                LoadAddrToReg Reg_A, CreateTACVar(TAC_VARIABLE, .Name, , .DType)
                                AddASM "test " & RegName(Reg_A, TYPE_INT) & ", " & RegName(Reg_A, TYPE_INT)
                                AddASM "jz " & strJmpLbl
                                AddASM "push " & RegName(Reg_A, TYPE_INT)
                                AddASM "call Delete"
                                AddASM strJmpLbl & ":"
                                
                            End If
                        End With
                    Next
                    
                    ' Jetzt darf Rckgabewert in EAX geschrieben werden
                    AddASM "mov " & RegName(Reg_A, TYPE_INT) & ", " & _
                                    RegName(Reg_B, TYPE_INT)

                    AddASM "jmp dword " & EXIT_PREFIX & m_strCurFunc
                
                Case TAC_CMD_RETRIEVE
                    AddASMComment "RETRIEVE"
                    StoreRegToMem Reg_A, .VarAssign
                
                Case TAC_CMD_GLOBALDECLARE
                    AddVar .VarAssign.VarName, .VarAssign.DataType, 0, _
                           False, True, "var_" & .VarAssign.VarName
                
                Case TAC_CMD_DECLARE
                    With .VarAssign
                        If .VarType = TAC_PARAM Then
                            lngParamCount = lngParamCount + 1
                            AddVar .VarName, .DataType, -(lngParamCount + 1) * 4, True
                        End If
                    End With
                
                Case TAC_CMD_IFZ, TAC_CMD_IF
                    TranslateIFZ i, ctx
                
                Case TAC_CMD_ASSIGN
                    TranslateAssign i, ctx
                
            End Select
        End With
    Next
End Sub

Private Sub TranslateIFZ(i As Long, ByVal ctx As TACContext)
    Dim strLblEnd  As String
    
    AddASMComment "IF"
    
    With ctx.Statement(i)
        If .Operator = NODE_NOT_DEFINED Then
            LoadAddrToReg Reg_A, .VarAssign
            AddASM "test " & RegName(Reg_A, TYPE_BOOL) & ", " & _
                             RegName(Reg_A, TYPE_BOOL)
            AddASM "jz " & .JumpLabel
        Else
            If .VarLeft.DataType <> TYPE_FLOAT Then
                LoadAddrToReg Reg_A, .VarLeft
                LoadAddrToReg Reg_B, .VarRight
                AddASM "cmp " & RegName(Reg_A, .VarLeft.DataType) & ", " & _
                                RegName(Reg_B, .VarRight.DataType)
                strLblEnd = .JumpLabel
            Else
                LoadAddrToFPU .VarRight
                LoadAddrToFPU .VarLeft
                AddASM "fcomip st0, st1"
                strLblEnd = CreateLabel()
            End If
            
            Select Case .VarLeft.DataType
                Case TYPE_FLOAT, TYPE_BYTE:
                    AddASM GetCmpJCC(.Operator, False, .Command = TAC_CMD_IFZ) _
                           & " " & strLblEnd
                Case Else
                    AddASM GetCmpJCC(.Operator, True, .Command = TAC_CMD_IFZ) _
                           & " " & strLblEnd
            End Select
             
            If .VarLeft.DataType = TYPE_FLOAT Then
                Dim strLblTotal As String: strLblTotal = ctx.CreateLabel()
                AddASM "jmp " & strLblTotal
                AddASM strLblEnd & ":"
                AddASM "fstp st0"
                AddASM "jmp " & .JumpLabel
                AddASM strLblTotal & ":"
            End If
        End If
    End With
End Sub

Private Function GetCmpJCC( _
    ByVal nd As NODE_TYPE, _
    ByVal blnSgn As Boolean, _
    ByVal blnNot As Boolean _
) As String

    If blnSgn Then
        If blnNot Then
            Select Case nd
                Case NODE_OP_CMP_EQU:       GetCmpJCC = "jne"
                Case NODE_OP_CMP_GRT:       GetCmpJCC = "jle"
                Case NODE_OP_CMP_GRTEQU:    GetCmpJCC = "jl"
                Case NODE_OP_CMP_NEQU:      GetCmpJCC = "je"
                Case NODE_OP_CMP_SML:       GetCmpJCC = "jge"
                Case NODE_OP_CMP_SMLEQU:    GetCmpJCC = "jg"
            End Select
        Else
            Select Case nd
                Case NODE_OP_CMP_EQU:       GetCmpJCC = "je"
                Case NODE_OP_CMP_GRT:       GetCmpJCC = "jg"
                Case NODE_OP_CMP_GRTEQU:    GetCmpJCC = "jge"
                Case NODE_OP_CMP_NEQU:      GetCmpJCC = "jne"
                Case NODE_OP_CMP_SML:       GetCmpJCC = "jl"
                Case NODE_OP_CMP_SMLEQU:    GetCmpJCC = "jle"
            End Select
        End If
    Else
        If blnNot Then
            Select Case nd
                Case NODE_OP_CMP_EQU:       GetCmpJCC = "jnz"
                Case NODE_OP_CMP_GRT:       GetCmpJCC = "jbe"
                Case NODE_OP_CMP_GRTEQU:    GetCmpJCC = "jb"
                Case NODE_OP_CMP_NEQU:      GetCmpJCC = "jz"
                Case NODE_OP_CMP_SML:       GetCmpJCC = "jae"
                Case NODE_OP_CMP_SMLEQU:    GetCmpJCC = "ja"
            End Select
        Else
            Select Case nd
                Case NODE_OP_CMP_EQU:       GetCmpJCC = "jz"
                Case NODE_OP_CMP_GRT:       GetCmpJCC = "ja"
                Case NODE_OP_CMP_GRTEQU:    GetCmpJCC = "jae"
                Case NODE_OP_CMP_NEQU:      GetCmpJCC = "jnz"
                Case NODE_OP_CMP_SML:       GetCmpJCC = "jb"
                Case NODE_OP_CMP_SMLEQU:    GetCmpJCC = "jbe"
            End Select
        End If
    End If
End Function

Private Sub TranslateAssign(i As Long, ByVal ctx As TACContext)
    With ctx.Statement(i)
        Select Case .Operator
        
            Case NODE_OP_NEG:
                AddASMComment "ASSIGN NEG"
                If .VarLeft.DataType = TYPE_FLOAT Then
                    LoadAddrToFPU .VarLeft
                    AddASM "fchs"
                    PopFPUToMem .VarAssign
                Else
                    LoadAddrToReg Reg_A, .VarLeft
                    AddASM "neg " & RegName(Reg_A, .VarLeft.DataType)
                    StoreRegToMem Reg_A, .VarAssign
                End If
        
            Case NODE_OP_ASSIGN:
                AddASMComment "ASSIGN ASGN"
                LoadAddrToReg Reg_A, .VarLeft
                StoreRegToMem Reg_A, .VarAssign
                
            Case NODE_OP_ADD, NODE_OP_SUB, NODE_OP_MUL, NODE_OP_DIV:
                AddASMComment "ASSIGN CALC"
                TranslateAssignMath ctx.Statement(i)
            
            Case NODE_OP_BAND, NODE_OP_BOR, NODE_OP_BXOR, NODE_OP_MOD:
                TranslateBitOps ctx.Statement(i)
                
            Case NODE_CONV_BYTE_TO_FLOAT, NODE_CONV_BYTE_TO_INT, _
                 NODE_CONV_BYTE_TO_SHORT, NODE_CONV_INT_TO_FLOAT, _
                 NODE_CONV_SHORT_TO_FLOAT, NODE_CONV_SHORT_TO_INT:
                AddASMComment "ASSIGN CONV"
                TranslateAssignConvert ctx.Statement(i)
            
            Case NODE_OP_CMP_EQU, NODE_OP_CMP_GRT, NODE_OP_CMP_GRTEQU, _
                 NODE_OP_CMP_NEQU, NODE_OP_CMP_SML, NODE_OP_CMP_SMLEQU:
                AddASMComment "ASSIGN COMP"
                TranslateCompare ctx.Statement(i)
            
        End Select
    End With
End Sub

Private Sub TranslateBitOps(ByVal tac As TACStatement)
    Dim strAction As String
    
    With tac
        If .Operator = NODE_OP_MOD Then
            LoadAddrToReg Reg_A, .VarLeft
            LoadAddrToReg Reg_B, .VarRight
            AddASM "xor " & RegName(Reg_D, TYPE_INT) & ", " & RegName(Reg_D, TYPE_INT)
            AddASM "idiv " & RegName(Reg_B, .VarRight.DataType)
            StoreRegToMem Reg_D, .VarAssign
        Else
            Select Case .Operator
                Case NODE_OP_BAND:  strAction = "and"
                Case NODE_OP_BOR:   strAction = "or"
                Case NODE_OP_BXOR:  strAction = "xor"
            End Select
            
            LoadAddrToReg Reg_A, .VarLeft
            LoadAddrToReg Reg_B, .VarRight
            AddASM strAction & " " & RegName(Reg_A, .VarLeft.DataType) & ", " & _
                                     RegName(Reg_B, .VarRight.DataType)
            StoreRegToMem Reg_A, .VarAssign
        End If
    End With
End Sub

Private Sub TranslateCompare(ByVal tac As TACStatement)
    Dim strLblJmp  As String: strLblJmp = CreateLabel()
    Dim strLblExit As String: strLblExit = CreateLabel()
    
    With tac
        If .VarLeft.DataType <> TYPE_FLOAT Then
            LoadAddrToReg Reg_A, .VarLeft
            LoadAddrToReg Reg_B, .VarRight
            AddASM "cmp " & RegName(Reg_A, .VarLeft.DataType) & ", " & _
                            RegName(Reg_B, .VarRight.DataType)
        Else
            LoadAddrToFPU .VarRight
            LoadAddrToFPU .VarLeft
            AddASM "fcomip st0, st1"
        End If
        
        Select Case .VarLeft.DataType
            Case TYPE_FLOAT, TYPE_BYTE:
                AddASM GetCmpJCC(.Operator, False, True) & " " & strLblJmp
            Case Else
                AddASM GetCmpJCC(.Operator, True, True) & " " & strLblJmp
        End Select
        
        If .Command = TAC_CMD_ASSIGN Then
            AddASM "mov dword " & GetVarAddr(.VarAssign.VarName, _
                                             .VarAssign.DataType) & ", -1"
        Else
            AddASM "mov " & RegName(Reg_A, TYPE_BOOL) & ", -1"
        End If
        
        AddASM "jmp dword " & strLblExit
        AddASM strLblJmp & ":"
        
        If .Command = TAC_CMD_ASSIGN Then
            AddASM "mov dword " & GetVarAddr(.VarAssign.VarName, _
                                             .VarAssign.DataType) & ", 0"
        Else
            AddASM "xor " & RegName(Reg_A, TYPE_BOOL) & ", " & _
                            RegName(Reg_A, TYPE_BOOL)
        End If
        
        AddASM strLblExit & ":"
        If .VarLeft.DataType = TYPE_FLOAT Then
            AddASM "fstp st0"
        End If
    End With
End Sub

Private Sub LoadAddrToFPU(ByVal var As TACVar)
    If var.VarType = TAC_VALUE Then
        AddASM "push dword " & GetFloatBytes(var.Content)
        AddASM "fld dword [esp]"
        AddASM "add esp, 4"
    Else
        AddASM "fld dword " & GetVarAddr(var.VarName, var.DataType)
    End If
End Sub

Private Function GetFloatBytes(ByVal f As Single) As Long
    Dim lng As Long
    CpyMem lng, f, 4
    GetFloatBytes = lng
End Function

Private Sub PopFPUToMem(ByVal var As TACVar)
    AddASM "fstp dword " & GetVarAddr(var.VarName, var.DataType)
End Sub

Private Sub TranslateAssignMathFloat(ByVal tac As TACStatement)
    With tac
        Select Case .Operator
            Case NODE_OP_ADD:
                LoadAddrToFPU .VarRight
                LoadAddrToFPU .VarLeft
                AddASM "fadd ST0, ST1"
                PopFPUToMem .VarAssign
            Case NODE_OP_SUB:
                LoadAddrToFPU .VarRight
                LoadAddrToFPU .VarLeft
                AddASM "fsub ST0, ST1"
                PopFPUToMem .VarAssign
            Case NODE_OP_MUL:
                LoadAddrToFPU .VarRight
                LoadAddrToFPU .VarLeft
                AddASM "fmul ST0, ST1"
                PopFPUToMem .VarAssign
            Case NODE_OP_DIV:
                LoadAddrToFPU .VarRight
                LoadAddrToFPU .VarLeft
                AddASM "fdiv ST0, ST1"
                PopFPUToMem .VarAssign
        End Select
        AddASM "ffree st0"
    End With
End Sub

Private Sub TranslateAssignMath(ByVal tac As TACStatement)
    With tac
        If .VarAssign.DataType = TYPE_FLOAT Then
            TranslateAssignMathFloat tac
        Else
            Select Case .Operator
                Case NODE_OP_ADD:
                    LoadAddrToReg Reg_A, .VarLeft
                    LoadAddrToReg Reg_B, .VarRight
                    AddASM "add " & RegName(Reg_A, .VarAssign.DataType) & ", " & _
                                    RegName(Reg_B, .VarAssign.DataType)
                    StoreRegToMem Reg_A, .VarAssign
                Case NODE_OP_SUB:
                    LoadAddrToReg Reg_A, .VarLeft
                    LoadAddrToReg Reg_B, .VarRight
                    AddASM "sub " & RegName(Reg_A, .VarAssign.DataType) & ", " & _
                                    RegName(Reg_B, .VarAssign.DataType)
                    StoreRegToMem Reg_A, .VarAssign
                Case NODE_OP_MUL:
                    LoadAddrToReg Reg_A, .VarLeft
                    LoadAddrToReg Reg_B, .VarRight
                    AddASM "imul " & RegName(Reg_B, .VarAssign.DataType)
                    StoreRegToMem Reg_A, .VarAssign
                Case NODE_OP_DIV:
                    LoadAddrToReg Reg_A, .VarLeft
                    LoadAddrToReg Reg_B, .VarRight
                    AddASM "xor " & RegName(Reg_D, TYPE_INT) & ", " & RegName(Reg_D, TYPE_INT)
                    AddASM "idiv " & RegName(Reg_B, .VarAssign.DataType)
                    StoreRegToMem Reg_A, .VarAssign
            End Select
        End If
    End With
End Sub

Private Sub TranslateAssignConvert(ByVal tac As TACStatement)
    With tac
        Select Case .Operator
            Case NODE_CONV_BYTE_TO_INT, NODE_CONV_BYTE_TO_SHORT:
                LoadAddrToReg Reg_B, .VarLeft
                AddASM "movzx " & RegName(Reg_A, .VarAssign.DataType) & ", " & _
                                  RegName(Reg_B, .VarLeft.DataType)
                StoreRegToMem Reg_A, .VarAssign
                
            Case NODE_CONV_SHORT_TO_INT:
                LoadAddrToReg Reg_B, .VarLeft
                AddASM "movsx " & RegName(Reg_A, .VarAssign.DataType) & ", " & _
                                  RegName(Reg_B, .VarLeft.DataType)
                StoreRegToMem Reg_A, .VarAssign
                
            Case NODE_CONV_BYTE_TO_FLOAT, _
                 NODE_CONV_SHORT_TO_FLOAT, _
                 NODE_CONV_INT_TO_FLOAT:
                
                LoadAddrToReg Reg_B, .VarLeft
                
                If .VarLeft.DataType <> TYPE_INT Then
                    If .VarLeft.DataType = TYPE_BYTE Then
                        AddASM "movzx " & RegName(Reg_A, TYPE_INT) & ", " & _
                                          RegName(Reg_B, .VarLeft.DataType)
                    Else
                        AddASM "movsx " & RegName(Reg_A, TYPE_INT) & ", " & _
                                          RegName(Reg_B, .VarLeft.DataType)
                    End If
                    AddASM "push " & RegName(Reg_A, TYPE_INT)
                Else
                    AddASM "push " & RegName(Reg_B, TYPE_INT)
                End If
                
                AddASM "fild dword [esp]"
                AddASM "fstp dword [esp]"
                AddASM "pop " & RegName(Reg_A, TYPE_FLOAT)
                StoreRegToMem Reg_A, .VarAssign
                
        End Select
    End With
End Sub

Private Sub StoreRegToMem(ByVal reg As Registers, ByVal nd As TACVar)
    Dim strAddr As String
    
    If nd.DeRef Then
        AddASM "mov " & RegName(Reg_C, TYPE_INT) & ", " & _
                        GetVarAddr(nd.VarName, nd.DataType)

        strAddr = "[" & RegName(Reg_C, TYPE_INT) & "]"
    Else
        strAddr = GetVarAddr(nd.VarName, nd.DataType)
    End If

    AddASM "mov " & strAddr & ", " & RegName(reg, nd.DataType)
End Sub

Private Sub LoadAddrToReg(ByVal reg As Registers, ByVal nd As TACVar)
    If nd.VarType = TAC_VALUE Then
        If nd.DataType = TYPE_BOOL Then
            AddASM "mov " & RegName(reg, nd.DataType) & ", " & _
                            IIf(nd.Content = True, -1, 0)
        Else
            If nd.DataType = TYPE_FLOAT Then
                AddASM "mov " & RegName(reg, nd.DataType) & ", " & GetFloatBytes(nd.Content)
            Else
                AddASM "mov " & RegName(reg, nd.DataType) & ", " & nd.Content
            End If
        End If
    Else
        If nd.DeRef Then
            AddASM "mov " & RegName(Reg_C, TYPE_INT) & ", " & _
                   GetVarAddr(nd.VarName, nd.DataType)
            AddASM "mov " & RegName(reg, nd.DataType) & ", " & _
                          "[" & RegName(Reg_C, TYPE_INT) & "]"
        Else
            AddASM "mov " & RegName(reg, nd.DataType) & ", " & _
                   GetVarAddr(nd.VarName, nd.DataType)
        End If
    End If
End Sub

Private Sub AddASMComment(ByVal strText As String)
    AddASM ";" & strText
End Sub

Private Sub AddASM(ByVal strText As String)
    m_strASM = m_strASM & strText & vbCrLf
End Sub

Private Sub DeclareGlobalVars()
    Dim strGlobal As String
    Dim i As Long
    
    For i = 0 To m_lngVarCount - 1
        If m_udtVars(i).IsGlobal Then
            strGlobal = strGlobal & "var_" & m_udtVars(i).Name & ":"
            Select Case StackSizeFromType(m_udtVars(i).DType)
                Case 1: strGlobal = strGlobal & " db 0" & vbCrLf
                Case 2: strGlobal = strGlobal & " dw 0" & vbCrLf
                Case 4: strGlobal = strGlobal & " dd 0" & vbCrLf
                Case Else: Err.Raise 1234, , "oh oh"
            End Select
        End If
    Next
    
    m_strASM = strGlobal & m_strASM
End Sub

Private Function GetVarAddr( _
    ByVal strName As String, _
    ByVal udeType As DATA_TYPE _
) As String

    GetVarAddr = MakeAddress(VarByName(strName, udeType))
End Function

Private Function MakeAddress(var As Variable) As String
    If var.IsGlobal Then
        MakeAddress = "[" & var.MemPos & "]"
    Else
        If var.StackPos < 0 Then
            MakeAddress = "[ebp+" & -var.StackPos & "]"
        Else
            MakeAddress = "[ebp" & -var.StackPos & "]"
        End If
    End If
End Function

Private Property Get StackSizeFromType(ByVal dt As DATA_TYPE) As Long
    Select Case dt
        Case TYPE_SHORT:    StackSizeFromType = 4
        Case TYPE_BYTE:     StackSizeFromType = 4
        Case Else:          StackSizeFromType = 4
    End Select
End Property

Private Property Get RegName( _
    ByVal reg As Registers, _
    ByVal sz As DATA_TYPE _
) As String

    If (sz And TYPE_ARRAY) Or (sz = TYPE_INT) Or _
       (sz = TYPE_BOOL) Or (sz = TYPE_FLOAT) Then
        Select Case reg
            Case Reg_A: RegName = "eax"
            Case Reg_B: RegName = "ebx"
            Case Reg_C: RegName = "ecx"
            Case Reg_D: RegName = "edx"
        End Select
    Else
        Select Case sz
            Case TYPE_BYTE
                Select Case reg
                    Case Reg_A: RegName = "al"
                    Case Reg_B: RegName = "bl"
                    Case Reg_C: RegName = "cl"
                    Case Reg_D: RegName = "dl"
                End Select
            Case TYPE_SHORT:
                Select Case reg
                    Case Reg_A: RegName = "ax"
                    Case Reg_B: RegName = "bx"
                    Case Reg_C: RegName = "cx"
                    Case Reg_D: RegName = "dx"
                End Select
            Case Else:
                Err.Raise 1234, , "NICHT UTNERSTTZER TYP"
        End Select
    End If
End Property

Public Function CreateLabel() As String
    CreateLabel = "AL" & m_lngLblCount
    m_lngLblCount = m_lngLblCount + 1
End Function
