VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Compiler"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private m_clsParser As Parser
Private m_clsWriter As ASMWriter2
Private m_udtASMMem As ASMMemory.Memory

Public Property Get AddrOfInit() As Long
    AddrOfInit = m_udtASMMem.InitPtr
End Property

Public Property Get AddrOfMain() As Long
    AddrOfMain = m_udtASMMem.MainPtr
End Property

Public Property Get AddrOfDSP() As Long
    AddrOfDSP = m_udtASMMem.DSPPtr
End Property

Public Property Get AddrOfDeinit() As Long
    AddrOfDeinit = m_udtASMMem.DeInitPtr
End Property

Public Function Compile(ByVal strCode As String) As Boolean
    Dim clsGlobal   As ParserGlobal
    Dim clsTAC      As TACContext
    Dim strASM      As String
    
    Set m_clsParser = New Parser
    Set m_clsWriter = New ASMWriter2
    Set clsTAC = New TACContext
    
    If m_udtASMMem.address <> 0 Then
        FreeMemory m_udtASMMem
    End If
    
    If m_clsParser.Parse(strCode, clsGlobal) Then
        Set clsTAC.ParserGlobal = clsGlobal
        ToIStatement(clsGlobal).GenerateTAC clsTAC
        strASM = m_clsWriter.TACtoASM(clsTAC)
        m_udtASMMem = AsmToMem(strASM)
        Compile = True
    End If
End Function

Public Property Get Errors() As Collection
    Set Errors = m_clsParser.Errors
End Property

Private Sub Class_Terminate()
    If m_udtASMMem.address <> 0 Then
        FreeMemory m_udtASMMem
    End If
End Sub
