VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ParserStatementDim"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Global?

Implements IStatement

Private m_strName       As String
Private m_blnArr        As Boolean
Private m_blnGlobal     As Boolean
Private m_clsSize       As ExpressionNode
Private m_udeDataType   As DATA_TYPE
Private m_clsAssignExpr As ExpressionNode

Public Property Get IsGlobal() As Boolean
    IsGlobal = m_blnGlobal
End Property

Public Property Let IsGlobal(ByVal blnVal As Boolean)
    m_blnGlobal = blnVal
End Property

Public Property Get IsArray() As Boolean
    IsArray = m_blnArr
End Property

Public Property Let IsArray(ByVal blnVal As Boolean)
    m_blnArr = blnVal
End Property

Public Property Get Size() As ExpressionNode
    Set Size = m_clsSize
End Property

Public Property Set Size(ByVal cls As ExpressionNode)
    Set m_clsSize = cls
End Property

Public Property Get Name() As String
    Name = m_strName
End Property

Public Property Let Name(ByVal strNewValue As String)
    m_strName = strNewValue
End Property

Public Property Get DataType() As DATA_TYPE
    DataType = m_udeDataType
End Property

Public Property Let DataType(ByVal udeNewValue As DATA_TYPE)
    m_udeDataType = udeNewValue
End Property

Public Property Get AssignExpr() As ExpressionNode
    Set AssignExpr = m_clsAssignExpr
End Property

Public Property Set AssignExpr(ByVal clsNewValue As ExpressionNode)
    Set m_clsAssignExpr = clsNewValue
End Property

Private Sub IStatement_DeclareVars(ByVal ctx As TACContext)
    Dim clsVar      As TACVar
    Dim clsSize     As TACVar
    Dim clsVarSize  As TACVar
    Dim clsAsgnVar  As TACVar
    
    Set clsVar = CreateTACVar(TAC_VARIABLE, Name, , DataType)
    If IsGlobal Then
        ctx.AddCode CreateTAC(TAC_CMD_GLOBALDECLARE, , , clsVar)
    Else
        ctx.AddCode CreateTAC(TAC_CMD_DECLARE, , , clsVar)
    End If
    
    If m_blnArr Then
        If Not Size Is Nothing Then
            Set clsSize = ToIStatement(Size).GenerateTAC(ctx)
            
            If clsSize.VarType = TAC_VARIABLE Then
                Dim clsVarCpy As TACVar
                Set clsVarCpy = CreateTempTACVar(ctx, clsSize.DataType)
                ctx.AddCode CreateTAC(TAC_CMD_ASSIGN, NODE_OP_ASSIGN, , clsVarCpy, clsSize)
                Set clsSize = clsVarCpy
            End If
            
            Set clsVarSize = CreateTACVar(TAC_VALUE, , ctx.ParserGlobal.VarBytes(DataType), TYPE_INT)
            If clsSize.VarType <> TAC_VALUE Then
                ctx.AddCode CreateTAC(TAC_CMD_ASSIGN, NODE_OP_MUL, , clsSize, clsSize, clsVarSize)
            Else
                Dim clsValVar As TACVar
                Set clsValVar = CreateTempTACVar(ctx, clsSize.DataType)
                ctx.AddCode CreateTAC(TAC_CMD_ASSIGN, NODE_OP_MUL, , clsValVar, clsSize, clsVarSize)
                Set clsSize = clsValVar
            End If
            
            ctx.AddCode CreateTAC(TAC_CMD_ALLOC, , , clsSize)
            ctx.AddCode CreateTAC(TAC_CMD_RETRIEVE, , , clsVar)
        Else
            ctx.AddCode CreateTAC(TAC_CMD_ASSIGN, NODE_OP_ASSIGN, , clsVar, CreateTACVar(TAC_VALUE, , 0, TYPE_INT))
        End If
    End If
    
    If Not m_blnGlobal Then GenerateCode ctx
End Sub

Private Sub IStatement_DestroyVars(ByVal ctx As TACContext)
    Dim clsVar As TACVar
    
    Set clsVar = CreateTACVar(TAC_VARIABLE, Name, , DataType)
    
    If Not Size Is Nothing Then
        ctx.AddCode CreateTAC(TAC_CMD_DELETE, , , clsVar)
    Else
        If IsArray Then
            Dim strLblReDim As String: strLblReDim = ctx.CreateLabel()
            ctx.AddCode CreateTAC(TAC_CMD_IFZ, , strLblReDim, clsVar)
            ctx.AddCode CreateTAC(TAC_CMD_DELETE, , , clsVar)
            ctx.AddLabel strLblReDim
        End If
    End If
End Sub

Private Function IStatement_GenerateTAC(ByVal ctx As TACContext) As TACVar
    If m_blnGlobal Then GenerateCode ctx
End Function

Private Sub GenerateCode(ByVal ctx As TACContext)
    Dim clsVar      As TACVar
    Dim clsAsgnVar  As TACVar
    
    Set clsVar = CreateTACVar(TAC_VARIABLE, Name, , DataType)
    If Not AssignExpr Is Nothing Then
        Set clsAsgnVar = ToIStatement(AssignExpr).GenerateTAC(ctx)
        ctx.AddCode CreateTAC(TAC_CMD_ASSIGN, NODE_OP_ASSIGN, , clsVar, clsAsgnVar)
    Else
        If Not m_blnArr Then
            Set clsAsgnVar = CreateTACVar(TAC_VALUE, , 0, DataType)
            ctx.AddCode CreateTAC(TAC_CMD_ASSIGN, NODE_OP_ASSIGN, , clsVar, clsAsgnVar)
        End If
    End If
End Sub
