VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DSPEqualizer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements IPlugin
Implements IPluginDSP

Private Const EQ_BANDS  As Long = 3

Private m_clsBands(EQ_BANDS - 1) As IIRFilter
Private m_clsMono       As Session
Private m_blnEnabled    As Boolean

Public Property Get MonoSession() As Session
    Set MonoSession = m_clsMono
End Property

Public Property Get enabled() As Boolean
    enabled = m_blnEnabled
End Property

Public Property Let enabled(ByVal blnVal As Boolean)
    m_blnEnabled = blnVal
End Property

Public Property Get BandCount() As Long
    BandCount = EQ_BANDS
End Property

Public Property Get BandValue(ByVal i As Long) As Single
    BandValue = m_clsBands(i).GainDB
End Property

Public Property Let BandValue(ByVal i As Long, ByVal val As Single)
    m_clsBands(i).GainDB = val
End Property

Private Property Get IPlugin_Description() As String
    IPlugin_Description = "Frequenzbnder regeln"
End Property

Private Property Get IPlugin_Name() As String
    IPlugin_Name = "Equalizer"
End Property

Private Property Get IPlugin_PluginType() As MonoPluginLib.PLUGIN_TYPE
    IPlugin_PluginType = PLUGIN_DSP
End Property

Private Sub IPluginDSP_FormatChanged(ByVal sr As Long, ByVal ch As Long)
    Dim i           As Long
    Dim lngFreq     As Long
    Dim sngBW       As Single
    Dim sngBFreq    As Single
    
    lngFreq = sr / 3
    sngBW = Log(lngFreq / 80#) / 4
    
    For i = 0 To EQ_BANDS - 1
        sngBFreq = 80# * (lngFreq / 80#) ^ (i / (EQ_BANDS - 1))
        With m_clsBands(i)
            .CreateBiquadIIR IIR_PEAK_EQ, .GainDB, sngBFreq, sr, sngBW
        End With
    Next
End Sub

Private Sub IPluginDSP_Init(ByVal mono As MonoPluginLib.Session)
    Set m_clsMono = mono
    
    Dim i As Long
    For i = 0 To EQ_BANDS - 1
        Set m_clsBands(i) = New IIRFilter
    Next
End Sub

Private Sub IPluginDSP_ProcessSamples(samples() As Single, ByVal lngOffset As Long, ByVal lngSamples As Long, lngReturned As Long)
    If m_blnEnabled Then
        Dim i As Long
        
        For i = 0 To EQ_BANDS - 1
            m_clsBands(i).ProcessSamples samples, lngOffset, lngSamples
        Next
    End If
    lngReturned = lngSamples
End Sub

Private Sub IPluginDSP_ShowConfig()
    EQSettings.LoadMe Me
End Sub

Private Sub IPluginDSP_Terminate()
    '
End Sub

Private Sub IPluginDSP_TrackChanged()
    '
End Sub
